All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
7 mr - a Multiple Repository management tool
11 B<mr> [options] checkout
13 B<mr> [options] update
15 B<mr> [options] status
17 B<mr> [options] commit [-m "message"]
23 B<mr> [options] register [repository]
25 B<mr> [options] config section ["parameter=[value]" ...]
27 B<mr> [options] action [params ...]
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
42 These predefined commands should be fairly familiar to users of any revision
47 =item checkout (or co)
49 Checks out any repositories that are not already checked out.
53 Updates each repository from its configured remote repository.
55 If a repository isn't checked out yet, it will first check it out.
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
67 The optional -m parameter allows specifying a commit message.
71 Show a diff of uncommitted changes.
79 These commands are also available:
85 List the repositories that mr will act on.
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
103 For example, to add (or edit) a repository in src/foo:
105 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
107 To show the command that mr uses to update the repository in src/foo:
109 mr config src/foo update
111 To see the built-in library of shell functions contained in mr:
113 mr config DEFAULT lib
115 The ~/.mrconfig file is used by default. To use a different config file,
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
157 Just operate on the repository for the current directory, do not
158 recurse into deeper repositories.
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
174 Here is an example .mrconfig file:
177 checkout = svn co svn://svn.example.com/src/trunk src
181 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
183 git checkout -b mybranch origin/master
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
189 The "DEFAULT" section allows setting default values for the sections that
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. (For the "register" action, "MR_REPO" is instead set to the
213 basename of the directory that should be created when checking the
216 The "MR_CONFIG" environment variable is set to the .mrconfig file
217 that defines the repo being acted on, or, if the repo is not yet in a config
218 file, the .mrconfig file that should be modified to register the repo.
220 A few parameters have special meanings:
226 If the "skip" parameter is set and its command returns true, then B<mr>
227 will skip acting on that repository. The command is passed the action
230 Here are two examples. The first skips the repo unless
231 mr is run by joey. The second uses the hours_since function
232 (included in mr's built-in library) to skip updating the repo unless it's
233 been at least 12 hours since the last update.
235 skip = test `whoami` != joey
236 skip = [ "$1" = update ] && ! hours_since "$1" 12
240 The "order" parameter can be used to override the default ordering of
241 repositories. The default order value is 10. Use smaller values to make
242 repositories be processed earlier, and larger values to make repositories
245 Note that if a repository is located in a subdirectory of another
246 repository, ordering it to be processed earlier is not recommended.
250 If the "chain" parameter is set and its command returns true, then B<mr>
251 will try to load a .mrconfig file from the root of the repository. (You
252 should avoid chaining from repositories with untrusted committers.)
256 If the "include" parameter is set, its command is ran, and should output
257 additional mrconfig file content. The content is included as if it were
258 part of the including file.
260 Unlike all other parameters, this parameter does not need to be placed
265 The "lib" parameter can specify some shell code that will be run before each
266 command, this can be a useful way to define shell functions for other commands
271 When looking for a command to run for a given action, mr first looks for
272 a parameter with the same name as the action. If that is not found, it
273 looks for a parameter named "rcs_action" (substituting in the name of the
274 revision control system and the action). The name of the revision control
275 system is itself determined by running each defined "rcs_test" action,
278 Internally, mr has settings for "git_update", "svn_update", etc. To change
279 the action that is performed for a given revision control system, you can
280 override these rcs specific actions. To add a new revision control system,
281 you can just add rcs specific actions for it.
285 Copyright 2007 Joey Hess <joey@kitenet.net>
287 Licensed under the GNU GPL version 2 or higher.
289 http://kitenet.net/~joey/code/mr/
298 use Cwd qw(getcwd abs_path);
300 # things that can happen when mr runs a command
309 my $config_overridden=0;
315 my $directory=getcwd();
316 $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
323 my (@ok, @failed, @skipped);
328 my ($action, $dir, $topdir, $subdir) = @_;
331 foreach my $rcs_test (
333 length $a <=> length $b
336 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
337 my ($rcs)=$rcs_test=~/(.*)_test/;
338 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
339 $test.="if my_$rcs_test; then echo $rcs; fi\n";
341 $test=$config{$topdir}{$subdir}{lib}."\n".$test
342 if exists $config{$topdir}{$subdir}{lib};
344 print "mr $action: running rcs test >>$test<<\n" if $verbose;
349 print STDERR "mr $action: found multiple possible repository types ($rcs) for $topdir$subdir\n";
360 sub findcommand { #{{{
361 my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
363 if (exists $config{$topdir}{$subdir}{$action}) {
364 return $config{$topdir}{$subdir}{$action};
371 my $rcs=rcs_test(@_);
374 exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
375 return $config{$topdir}{$subdir}{$rcs."_".$action};
383 my ($action, $dir, $topdir, $subdir) = @_;
385 $ENV{MR_CONFIG}=$configfiles{$topdir};
386 my $lib=exists $config{$topdir}{$subdir}{lib} ?
387 $config{$topdir}{$subdir}{lib}."\n" : "";
388 my $is_checkout=($action eq 'checkout');
392 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
396 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
398 elsif ($action =~ /update/) {
400 return action("checkout", $dir, $topdir, $subdir);
406 my $skiptest=findcommand("skip", $dir, $topdir, $subdir, $is_checkout);
407 my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
409 if (defined $skiptest) {
410 my $test="set -e;".$lib.
411 "my_action(){ $skiptest\n }; my_action '$action'";
412 print "mr $action: running skip test >>$test<<\n" if $verbose;
413 my $ret=system($test);
415 if (($? & 127) == 2) {
416 print STDERR "mr $action: interrupted\n";
420 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
424 if ($ret >> 8 == 0) {
425 print "mr $action: $dir skipped per config file\n" if $verbose;
430 if ($is_checkout && ! -d $dir) {
431 print "mr $action: creating parent directory $dir\n" if $verbose;
432 system("mkdir", "-p", $dir);
435 if (! $no_chdir && ! chdir($dir)) {
436 print STDERR "mr $action: failed to chdir to $dir: $!\n";
439 elsif (! defined $command) {
440 my $rcs=rcs_test(@_);
441 if (! defined $rcs) {
442 print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
446 print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
452 print "mr $action: $topdir$subdir\n";
456 $s=~s/^\Q$topdir$subdir\E\/?//;
457 print "mr $action: $topdir$subdir (in subdir $s)\n";
459 $command="set -e; ".$lib.
460 "my_action(){ $command\n }; my_action ".
461 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
462 print "mr $action: running >>$command<<\n" if $verbose;
463 my $ret=system($command);
465 if (($? & 127) == 2) {
466 print STDERR "mr $action: interrupted\n";
470 print STDERR "mr $action: received signal ".($? & 127)."\n";
473 print STDERR "mr $action: failed ($ret)\n" if $verbose;
474 if ($ret >> 8 != 0) {
475 print STDERR "mr $action: command failed\n";
478 print STDERR "mr $action: command died ($ret)\n";
483 if ($action eq 'checkout' && ! -d $dir) {
484 print STDERR "mr $action: $dir missing after checkout\n";;
493 # run actions on multiple repos, in parallel
503 while (@fhs or @repos) {
504 while ($running < $jobs && @repos) {
506 my $repo = shift @repos;
507 pipe(my $outfh, CHILD_STDOUT);
508 pipe(my $errfh, CHILD_STDERR);
510 unless ($pid = fork) {
511 die "mr $action: cannot fork: $!" unless defined $pid;
512 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
513 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
518 exit action($action, @$repo);
522 push @active, [$pid, $repo];
523 push @fhs, [$outfh, $errfh];
526 my ($rin, $rout) = ('','');
528 foreach my $fh (@fhs) {
529 next unless defined $fh;
530 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
531 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
533 $nfound = select($rout=$rin, undef, undef, 1);
534 foreach my $channel (0, 1) {
535 foreach my $i (0..$#fhs) {
536 next unless defined $fhs[$i];
537 my $fh = $fhs[$i][$channel];
538 next unless defined $fh;
539 if (vec($rout, fileno($fh), 1) == 1) {
541 if (sysread($fh, $r, 1024) == 0) {
543 $fhs[$i][$channel] = undef;
544 if (! defined $fhs[$i][0] &&
545 ! defined $fhs[$i][1]) {
546 waitpid($active[$i][0], 0);
547 print STDOUT $out[$i][0];
548 print STDERR $out[$i][1];
549 record($active[$i][1], $? >> 8);
551 splice(@active, $i, 1);
556 $out[$i][$channel] .= $r;
564 my $dir=shift()->[0];
571 elsif ($ret == FAILED) {
575 elsif ($ret == SKIPPED) {
578 elsif ($ret == ABORT) {
582 die "unknown exit status $ret";
588 if (! @ok && ! @failed && ! @skipped) {
589 die "mr $action: no repositories found to work on\n";
591 print "mr $action: finished (".join("; ",
592 showstat($#ok+1, "ok", "ok"),
593 showstat($#failed+1, "failed", "failed"),
594 showstat($#skipped+1, "skipped", "skipped"),
598 print "mr $action: (skipped: ".join(" ", @skipped).")\n";
601 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
611 return "$count ".($count > 1 ? $plural : $singular);
616 # an ordered list of repos
619 foreach my $topdir (sort keys %config) {
620 foreach my $subdir (sort keys %{$config{$topdir}}) {
624 order => $config{$topdir}{$subdir}{order},
629 $a->{order} <=> $b->{order}
631 $a->{topdir} cmp $b->{topdir}
633 $a->{subdir} cmp $b->{subdir}
637 # figure out which repos to act on
638 sub selectrepos { #{{{
640 foreach my $repo (repolist()) {
641 my $topdir=$repo->{topdir};
642 my $subdir=$repo->{subdir};
644 next if $subdir eq 'DEFAULT';
645 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
647 $dir.="/" unless $dir=~/\/$/;
648 $d.="/" unless $d=~/\/$/;
649 next if $no_recurse && $d ne $dir;
650 next if $dir ne $d && $dir !~ /^\Q$d\E/;
651 push @repos, [$dir, $topdir, $subdir];
654 # fallback to find a leaf repo
655 foreach my $repo (reverse repolist()) {
656 my $topdir=$repo->{topdir};
657 my $subdir=$repo->{subdir};
659 next if $subdir eq 'DEFAULT';
660 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
662 $dir.="/" unless $dir=~/\/$/;
663 $d.="/" unless $d=~/\/$/;
664 if ($d=~/^\Q$dir\E/) {
665 push @repos, [$dir, $topdir, $subdir];
675 sub loadconfig { #{{{
682 if (ref $f eq 'GLOB') {
691 my $absf=abs_path($f);
692 if ($loaded{$absf}) {
697 ($dir)=$f=~/^(.*\/)[^\/]+$/;
698 if (! defined $dir) {
701 $dir=abs_path($dir)."/";
703 if (! exists $configfiles{$dir}) {
704 $configfiles{$dir}=$f;
707 # copy in defaults from first parent
709 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
710 if ($parent eq '/') {
713 if (exists $config{$parent} &&
714 exists $config{$parent}{DEFAULT}) {
715 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
720 print "mr: loading config $f\n" if $verbose;
721 open($in, "<", $f) || die "mr: open $f: $!\n";
732 next if /^\s*\#/ || /^\s*$/;
733 if (/^\[([^\]]*)\]\s*$/) {
736 elsif (/^(\w+)\s*=\s*(.*)/) {
741 while (@lines && $lines[0]=~/^\s(.+)/) {
748 if ($parameter eq "include") {
749 print "mr: including output of \"$value\"\n" if $verbose;
750 unshift @lines, `$value`;
754 if (! defined $section) {
755 die "$f line $.: parameter ($parameter) not in section\n";
757 if ($section ne 'ALIAS' &&
758 ! exists $config{$dir}{$section} &&
759 exists $config{$dir}{DEFAULT}) {
761 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
763 if ($section eq 'ALIAS') {
764 $alias{$parameter}=$value;
766 elsif ($parameter eq 'lib') {
767 $config{$dir}{$section}{lib}.=$value."\n";
770 $config{$dir}{$section}{$parameter}=$value;
771 if ($parameter =~ /.*_(.*)/) {
775 $knownactions{$parameter}=1;
777 if ($parameter eq 'chain' &&
778 length $dir && $section ne "DEFAULT" &&
779 -e $dir.$section."/.mrconfig") {
780 my $ret=system($value);
782 if (($? & 127) == 2) {
783 print STDERR "mr: chain test interrupted\n";
787 print STDERR "mr: chain test received signal ".($? & 127)."\n";
791 push @toload, $dir.$section."/.mrconfig";
797 die "$f line $line: parse error\n";
806 sub modifyconfig { #{{{
808 # the section to modify or add
809 my $targetsection=shift;
810 # fields to change in the section
811 # To remove a field, set its value to "".
818 open(my $in, "<", $f) || die "mr: open $f: $!\n";
823 my $formatfield=sub {
825 my @value=split(/\n/, shift);
827 return "$field = ".shift(@value)."\n".
828 join("", map { "\t$_\n" } @value);
832 while ($out[$#out] =~ /^\s*$/) {
833 unshift @blanks, pop @out;
835 foreach my $field (sort keys %changefields) {
836 if (length $changefields{$field}) {
837 push @out, "$field = $changefields{$field}\n";
838 delete $changefields{$field};
848 if (/^\s*\#/ || /^\s*$/) {
851 elsif (/^\[([^\]]*)\]\s*$/) {
852 if (defined $section &&
853 $section eq $targetsection) {
861 elsif (/^(\w+)\s*=\s(.*)/) {
866 while (@lines && $lines[0]=~/^\s(.+)/) {
872 if ($section eq $targetsection) {
873 if (exists $changefields{$parameter}) {
874 if (length $changefields{$parameter}) {
875 $value=$changefields{$parameter};
877 delete $changefields{$parameter};
881 push @out, $formatfield->($parameter, $value);
885 if (defined $section &&
886 $section eq $targetsection) {
889 elsif (%changefields) {
890 push @out, "\n[$targetsection]\n";
891 foreach my $field (sort keys %changefields) {
892 if (length $changefields{$field}) {
893 push @out, $formatfield->($field, $changefields{$field});
898 open(my $out, ">", $f) || die "mr: write $f: $!\n";
906 # actions that do not operate on all repos
907 if ($action eq 'help') {
910 elsif ($action eq 'config') {
913 elsif ($action eq 'register') {
918 mrs($action, selectrepos());
921 foreach my $repo (selectrepos()) {
922 record($repo, action($action, @$repo));
928 exec($config{''}{DEFAULT}{help}) || die "exec: $!";
933 die "mr config: not enough parameters\n";
936 if ($section=~/^\//) {
937 # try to convert to a path relative to the config file
938 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
940 $dir.="/" unless $dir=~/\/$/;
941 if ($section=~/^\Q$dir\E(.*)/) {
947 if (/^([^=]+)=(.*)$/) {
948 $changefields{$1}=$2;
952 foreach my $topdir (sort keys %config) {
953 if (exists $config{$topdir}{$section} &&
954 exists $config{$topdir}{$section}{$_}) {
955 print $config{$topdir}{$section}{$_}."\n";
957 last if $section eq 'DEFAULT';
961 die "mr config: $section $_ not set\n";
965 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
970 if (! $config_overridden) {
971 # Find the closest known mrconfig file to the current
973 $directory.="/" unless $directory=~/\/$/;
975 foreach my $topdir (reverse sort keys %config) {
976 next unless length $topdir;
977 if ($directory=~/^\Q$topdir\E/) {
978 $ENV{MR_CONFIG}=$configfiles{$topdir};
984 if (! $foundconfig) {
985 $directory=""; # no config file, use builtin
989 my $subdir=shift @ARGV;
990 if (! chdir($subdir)) {
991 print STDERR "mr register: failed to chdir to $subdir: $!\n";
995 $ENV{MR_REPO}=getcwd();
996 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
997 if (! defined $command) {
998 die "mr register: unknown repository type\n";
1001 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
1002 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
1003 "my_action(){ $command\n }; my_action ".
1004 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
1005 print "mr register: running >>$command<<\n" if $verbose;
1006 exec($command) || die "exec: $!";
1009 # alias expansion and command stemming
1010 sub expandaction { #{{{
1012 if (exists $alias{$action}) {
1013 $action=$alias{$action};
1015 if (! exists $knownactions{$action}) {
1016 my @matches = grep { /^\Q$action\E/ }
1017 keys %knownactions, keys %alias;
1018 if (@matches == 1) {
1019 $action=$matches[0];
1021 elsif (@matches == 0) {
1022 die "mr: unknown action \"$action\" (known actions: ".
1023 join(", ", sort keys %knownactions).")\n";
1026 die "mr: ambiguous action \"$action\" (matches: ".
1027 join(", ", @matches).")\n";
1034 Getopt::Long::Configure("bundling", "no_permute");
1035 my $result=GetOptions(
1036 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1037 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1038 "v|verbose" => \$verbose,
1039 "s|stats" => \$stats,
1040 "n|no-recurse" => \$no_recurse,
1041 "j|jobs=i" => \$jobs,
1043 if (! $result || @ARGV < 1) {
1044 die("Usage: mr [-d directory] action [params ...]\n".
1045 "(Use mr help for man page.)\n");
1051 print STDERR "mr: interrupted\n";
1055 # This can happen if it's run in a directory that was removed
1056 # or other strangeness.
1057 if (! defined $directory) {
1058 die("mr: failed to determine working directory\n");
1060 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1061 # the config file might be a symlink to elsewhere, and the directory it's
1062 # in is significant.
1063 if ($ENV{MR_CONFIG} !~ /^\//) {
1064 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1066 # Try to set MR_PATH to the path to the program.
1068 use FindBin qw($Bin $Script);
1069 $ENV{MR_PATH}=$Bin."/".$Script;
1077 loadconfig($ENV{MR_CONFIG});
1078 #use Data::Dumper; print Dumper(\%config);
1080 my $action=expandaction(shift @ARGV);
1087 elsif (! @ok && @skipped) {
1095 # Finally, some useful actions that mr knows about by default.
1096 # These can be overridden in ~/.mrconfig.
1112 echo "mr (warning): $@" >&2
1118 if [ -z "$1" ] || [ -z "$2" ]; then
1119 error "mr: usage: hours_since action num"
1121 for dir in .git .svn .bzr CVS .hg _darcs; do
1122 if [ -e "$MR_REPO/$dir" ]; then
1123 flagfile="$MR_REPO/$dir/.mr_last$1"
1127 if [ -z "$flagfile" ]; then
1128 error "cannot determine flag filename"
1130 delta=`perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"`
1131 if [ "$delta" -lt "$2" ]; then
1139 svn_test = test -d "$MR_REPO"/.svn
1140 git_test = test -d "$MR_REPO"/.git
1141 bzr_test = test -d "$MR_REPO"/.bzr
1142 cvs_test = test -d "$MR_REPO"/CVS
1143 hg_test = test -d "$MR_REPO"/.hg
1144 darcs_test = test -d "$MR_REPO"/_darcs
1146 test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1147 test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1148 test "`GIT_CONFIG="$MR_REPO"/config git config --get core.bare`" = true
1150 svn_update = svn update "$@"
1151 git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
1152 bzr_update = bzr merge "$@"
1153 cvs_update = cvs update "$@"
1154 hg_update = hg pull "$@" && hg update "$@"
1155 darcs_update = darcs pull -a "$@"
1157 svn_status = svn status "$@"
1158 git_status = git status "$@" || true
1159 bzr_status = bzr status "$@"
1160 cvs_status = cvs status "$@"
1161 hg_status = hg status "$@"
1162 darcs_status = darcs whatsnew -ls "$@"
1164 svn_commit = svn commit "$@"
1165 git_commit = git commit -a "$@" && git push --all
1166 bzr_commit = bzr commit "$@" && bzr push
1167 cvs_commit = cvs commit "$@"
1168 hg_commit = hg commit -m "$@" && hg push
1169 darcs_commit = darcs commit -a -m "$@" && darcs push -a
1171 svn_diff = svn diff "$@"
1172 git_diff = git diff "$@"
1173 bzr_diff = bzr diff "$@"
1174 cvs_diff = cvs diff "$@"
1175 hg_diff = hg diff "$@"
1176 darcs_diff = darcs diff "$@"
1178 svn_log = svn log "$@"
1179 git_log = git log "$@"
1180 bzr_log = bzr log "$@"
1181 cvs_log = cvs log "$@"
1182 hg_log = hg log "$@"
1183 darcs_log = darcs changes "$@"
1184 git_bare_log = git log "$@"
1187 url=`LANG=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
1188 if [ -z "$url" ]; then
1189 error "cannot determine svn url"
1191 echo "Registering svn url: $url in $MR_CONFIG"
1192 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1194 url="`LANG=C git config --get remote.origin.url`" || true
1195 if [ -z "$url" ]; then
1196 error "cannot determine git url"
1198 echo "Registering git url: $url in $MR_CONFIG"
1199 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1201 url=`cat .bzr/branch/parent`
1202 if [ -z "$url" ]; then
1203 error "cannot determine bzr url"
1205 echo "Registering bzr url: $url in $MR_CONFIG"
1206 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
1208 repo=`cat CVS/Repository`
1210 if [ -z "$root" ]; then
1211 error "cannot determine cvs root"
1213 echo "Registering cvs repository $repo at root $root"
1214 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1216 url=`hg showconfig paths.default`
1217 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1218 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1220 url=`cat _darcs/prefs/defaultrepo`
1221 echo "Registering darcs repository $url in $MR_CONFIG"
1222 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url'p '$MR_REPO'"
1224 url="`LANG=C GIT_CONFIG=config git config --get remote.origin.url`" || true
1225 if [ -z "$url" ]; then
1226 error "cannot determine git url"
1228 echo "Registering git url: $url in $MR_CONFIG"
1229 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1232 if [ ! -e "$MR_PATH" ]; then
1233 error "cannot find program path"
1235 (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1239 ed = echo "A horse is a horse, of course, of course.."
1240 T = echo "I pity the fool."
1241 right = echo "Not found."
1244 # vim:sw=8:sts=0:ts=8:noet